//+------------------------------------------------------------------+
//|                                          adaptive price zone.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers  3
#property indicator_color1   Lime
#property indicator_color2   Red
#property indicator_color3   White
#property indicator_style1   STYLE_DOT
#property indicator_style2   STYLE_DOT
#property indicator_style3   STYLE_DOT

//
//
//
//
//

extern int    emaPeriod         = 14;
extern int    emaPrice          = PRICE_CLOSE;
extern double bandPercent       = 2;
extern bool   alertsOn          = True;
bool   alertsOnCurrent   = false;
int MaxBars = 1;
extern int alert_bar = 1;
extern bool   alertsMessage     = true;
extern bool   alertsSound       = false;
extern bool   alertsEmail       = false;
extern bool   alertsPush        = true;
extern bool ShowArrows = true;
extern color ArrowsUpColor = Green,
             ArrowsDnColor = Red;
extern int ArrowsSize=3;      
extern int buffer_points = 0; 
extern bool reversal_only = false;      

//
//
//
//
//

double upBuffer[];
double dnBuffer[];
double mdBuffer[];
double trend[];
double wrkBuffer[][4];
double alpha;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,upBuffer);
   SetIndexBuffer(1,dnBuffer);
   SetIndexBuffer(2,mdBuffer);
   SetIndexBuffer(3,trend);
   emaPeriod = MathMax(emaPeriod,1);
       alpha = 2.0 /(1.0+MathSqrt(emaPeriod));
   
   return(0);
}
void deinit() {
   if (ShowArrows) {
      for (int i=ObjectsTotal()-1;i>=0;i--) {
         if (StringFind(ObjectName(i),"Trade:")>-1) ObjectDelete(ObjectName(i));
         }
      }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define emaa 0
#define emab 1
#define rnga 2
#define rngb 3

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(wrkBuffer,0) != Bars) ArrayResize(wrkBuffer,Bars);
         
   //
   //
   //
   //
   //
            
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,emaPrice,i);
      double range = iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH,i)-iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW,i);
         if (i==Bars-1)
         {
            upBuffer[i]        = price;
            dnBuffer[i]        = price;
            wrkBuffer[r][emaa] = price;
            wrkBuffer[r][emab] = price;
            wrkBuffer[r][rnga] = range;
            wrkBuffer[r][rngb] = range;
            continue;
         }
         wrkBuffer[r][emaa] = wrkBuffer[r-1][emaa]+alpha*(price             -wrkBuffer[r-1][emaa]);
         wrkBuffer[r][emab] = wrkBuffer[r-1][emab]+alpha*(wrkBuffer[r][emaa]-wrkBuffer[r-1][emab]);
         wrkBuffer[r][rnga] = wrkBuffer[r-1][rnga]+alpha*(range             -wrkBuffer[r-1][rnga]);
         wrkBuffer[r][rngb] = wrkBuffer[r-1][rngb]+alpha*(wrkBuffer[r][rnga]-wrkBuffer[r-1][rngb]);

         //
         //
         //
         //
         //
         
         upBuffer[i] = wrkBuffer[r][emab]+bandPercent*wrkBuffer[r][rngb]-buffer_points*Point;
         dnBuffer[i] = wrkBuffer[r][emab]-bandPercent*wrkBuffer[r][rngb]+buffer_points*Point;
         mdBuffer[i] = wrkBuffer[r][emab];
         //trend[i]    = trend[i+1];
         trend[i] = 0;
         if (High[i]>upBuffer[i]) trend[i] =  1;
         if (Low[i] <dnBuffer[i]) trend[i] = -1;
         if (ShowArrows) 
         {
            //ObjectDelete("Trade:"+Time[i]);
            if (trend[i]!=trend[i+1] || !reversal_only)
            {
               if (trend[i]== 1) DrawArrow(i,ArrowsDnColor,234,true);
               if (trend[i]==-1) DrawArrow(i,ArrowsUpColor,233,false);
            }      
         }               
   }
   
   
   if (alertsOn)
   {
      string name = "Trade:"+Time[alert_bar];
      double apz = 0;
      if (ObjectFind(0,name)>=0)
      {
         color clr = ObjectGet(name,OBJPROP_COLOR);
         if (clr==ArrowsDnColor)
         {
            doAlert(alert_bar," APZ high crossed upper band at ");
         }
         else if (clr==ArrowsUpColor)
         {
            doAlert(alert_bar," APZ low crossed lower band at ");
         }
      }
   }
   
   
   
   //manageAlerts();
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts() {
   int whichBar;
   int start_bar = 0;
   if (alertsOnCurrent)
      start_bar = 0;
   else start_bar = 1;
   
   for (int i=start_bar;i<=MaxBars;i++)
   {
      whichBar = i;
      if (trend[whichBar] != trend[whichBar+1]) 
      {
         if (trend[whichBar] ==  1) {
            if (alertsOn) doAlert(whichBar," APZ high crossed upper band at ");
            }
         if (trend[whichBar] == -1) {
            if (alertsOn) doAlert(whichBar," APZ low crossed lower band at ");
            }
      }
   }
   
   
   
   
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   //if (previousAlert != doWhat || previousTime != Time[forBar]) {
   if (previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //
       //int whichBar;
       //if (alertsOnCurrent)
         //whichBar = 0;
       //else whichBar = 1;
       //message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ",EnumToString((ENUM_TIMEFRAMES)Period())," adaptive price zone ",doWhat);
       //string message_lo = Symbol()+"_"+EnumToString((ENUM_TIMEFRAMES)Period())+" APZ low crossed lower band at "+upBuffer[whichBar];
       //string message_hi = Symbol()+"_"+EnumToString((ENUM_TIMEFRAMES)Period())+" APZ high crossed upper band at "+dnBuffer[whichBar];
       
       if (StringFind(doWhat,"low")>=0)
         message = Symbol()+"_"+EnumToString((ENUM_TIMEFRAMES)Period())+doWhat+dnBuffer[forBar];
       else if (StringFind(doWhat,"high")>=0)
         message = Symbol()+"_"+EnumToString((ENUM_TIMEFRAMES)Period())+doWhat+upBuffer[forBar];  
       
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," adaptive price zone "),message);
          if (alertsPush)    SendNotification(message);
          if (alertsSound)   PlaySound("alert.wav");
   }
}
void DrawArrow(int i,color theColor,int theCode,bool up) {
   string name = "Trade:"+Time[i];
   double gap  = 3.0*iATR(NULL,0,20,i)/4.0;   
   ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
      ObjectSet(name,OBJPROP_ARROWCODE,theCode);
      ObjectSet(name,OBJPROP_COLOR,theColor);
      ObjectSet(name,OBJPROP_WIDTH,ArrowsSize);
      if (up)
            ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
      else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap);
}